# blending.mod
param Cmax integer;   # Number of crudes
param Nfuels integer; # Number of different fuels

set C := 1..Cmax;
set F := 1..Nfuels;

param res{C};         # Storage of each crude
param mix_min{C,F};   # Minimum required of a certain crude
param mix_max{C,F};   # Maximum allowed of a certain crude
param price{C};       # Each crude has a price
param revenue{F};     # Each fuel gains money

var q{C,F} >= 0.0;    # quantity of crude in fuel

maximize gain: sum{i in C, j in F} (revenue[j] - price[i])*q[i,j];

subject to reserve{i in C}: sum{j in F} q[i,j] <= res[i];

subject to mix_constraint1{i in C, j in F}:
	q[i,j] <= mix_max[i,j]*sum{h in C} q[h,j];
	
subject to mix_constraint2{i in C, j in F}:
	q[i,j] >= mix_min[i,j]*sum{h in C} q[h,j];
